using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using System.Diagnostics;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel topPanel;
		private System.Windows.Forms.Panel bottomPanel;
		private System.Windows.Forms.TreeView attributeTreeView;
		private System.Windows.Forms.Button loadBtn;
		private System.Windows.Forms.Button closeBtn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.topPanel = new System.Windows.Forms.Panel();
			this.bottomPanel = new System.Windows.Forms.Panel();
			this.attributeTreeView = new System.Windows.Forms.TreeView();
			this.loadBtn = new System.Windows.Forms.Button();
			this.closeBtn = new System.Windows.Forms.Button();
			this.topPanel.SuspendLayout();
			this.bottomPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// topPanel
			// 
			this.topPanel.Controls.Add(this.loadBtn);
			this.topPanel.Dock = System.Windows.Forms.DockStyle.Top;
			this.topPanel.Location = new System.Drawing.Point(0, 0);
			this.topPanel.Name = "topPanel";
			this.topPanel.Size = new System.Drawing.Size(752, 48);
			this.topPanel.TabIndex = 0;
			// 
			// bottomPanel
			// 
			this.bottomPanel.Controls.Add(this.closeBtn);
			this.bottomPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.bottomPanel.Location = new System.Drawing.Point(0, 510);
			this.bottomPanel.Name = "bottomPanel";
			this.bottomPanel.Size = new System.Drawing.Size(752, 32);
			this.bottomPanel.TabIndex = 1;
			// 
			// attributeTreeView
			// 
			this.attributeTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.attributeTreeView.ImageIndex = -1;
			this.attributeTreeView.Location = new System.Drawing.Point(0, 48);
			this.attributeTreeView.Name = "attributeTreeView";
			this.attributeTreeView.SelectedImageIndex = -1;
			this.attributeTreeView.Size = new System.Drawing.Size(752, 462);
			this.attributeTreeView.TabIndex = 2;
			// 
			// loadBtn
			// 
			this.loadBtn.Location = new System.Drawing.Point(480, 12);
			this.loadBtn.Name = "loadBtn";
			this.loadBtn.Size = new System.Drawing.Size(96, 23);
			this.loadBtn.TabIndex = 0;
			this.loadBtn.Text = "Get Attributes";
			this.loadBtn.Click += new System.EventHandler(this.loadBtn_Click);
			// 
			// closeBtn
			// 
			this.closeBtn.Location = new System.Drawing.Point(664, 6);
			this.closeBtn.Name = "closeBtn";
			this.closeBtn.TabIndex = 0;
			this.closeBtn.Text = "Close";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(752, 542);
			this.Controls.Add(this.attributeTreeView);
			this.Controls.Add(this.bottomPanel);
			this.Controls.Add(this.topPanel);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Attribute Explorer";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.topPanel.ResumeLayout(false);
			this.bottomPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void GetAttributes(System.Type classType,TreeNode baseNode)
		{
			// Add attributes for the class
			TreeNode classNode = new TreeNode("Class attributes");
			AddCustomAttributes(classType.GetCustomAttributes(true),classType.Attributes,classNode);
			baseNode.Nodes.Add(classNode);

			// Add attributes for the fields
			TreeNode fieldNode = new TreeNode("Field attributes");

			foreach (FieldInfo fieldInfo in classType.GetFields())
			{
				TreeNode newFieldNode = new TreeNode(fieldInfo.Name);
				AddCustomAttributes(fieldInfo.GetCustomAttributes(true),fieldInfo.Attributes,newFieldNode);
				fieldNode.Nodes.Add(newFieldNode);
			}

			baseNode.Nodes.Add(fieldNode);

			// Add attributes for the properties
			TreeNode propertyNode = new TreeNode("Property attributes");

			foreach (PropertyInfo propInfo in classType.GetProperties())
			{
				TreeNode newPropNode = new TreeNode(propInfo.Name);
				AddCustomAttributes(propInfo.GetCustomAttributes(true),propInfo.Attributes,newPropNode);
				propertyNode.Nodes.Add(newPropNode);
			}

			baseNode.Nodes.Add(propertyNode);

			// Add attributes for the methods
			TreeNode methodNode = new TreeNode("Method attributes");

			foreach (MethodInfo methodInfo in classType.GetMethods())
			{
				TreeNode newMethodNode = new TreeNode(methodInfo.Name);
				AddCustomAttributes(methodInfo.GetCustomAttributes(true),methodInfo.Attributes,newMethodNode);
				methodNode.Nodes.Add(newMethodNode);
			}

			baseNode.Nodes.Add(methodNode);
		}

		private void AddCustomAttributes(object[] customAttributes,System.Enum intrinsicAttributes,TreeNode baseNode)
		{
			// Find all the custom attributes
			TreeNode customNode = new TreeNode("Custom attributes");
			baseNode.Nodes.Add(customNode);

			foreach (Attribute attribute in customAttributes)
			{
				TreeNode newNode = new TreeNode(attribute.ToString());
				customNode.Nodes.Add(newNode);
			}

			// Display the intrinsic properties
			TreeNode intrinsicNode = new TreeNode();
			intrinsicNode.Text = string.Format("Intrinsic attributes : {0}",intrinsicAttributes);
			baseNode.Nodes.Add(intrinsicNode);
		}

		private void loadBtn_Click(object sender, System.EventArgs e)
		{
			System.Type exploreType = typeof(BadBeer);
			TreeNode rootNode = new TreeNode(exploreType.Name);

			attributeTreeView.Nodes.Clear();
			attributeTreeView.Nodes.Add(rootNode);
			GetAttributes(exploreType,rootNode);
			attributeTreeView.ExpandAll();
		}

	}
}
